SystemOrganization addCategory: #Seamless!
SystemOrganization addCategory: #'Seamless-DataTransporter'!
SystemOrganization addCategory: #'Seamless-Transcoder'!
SystemOrganization addCategory: #'Seamless-ObjectTransporter'!
SystemOrganization addCategory: #'Seamless-Data-Transporter'!
SystemOrganization addCategory: #'Seamless-Object-Transporter'!
SystemOrganization addCategory: #'Seamless-Proxies'!
SystemOrganization addCategory: #'Seamless-Connection'!

Trait named: #TSeamlessRemoteProxy
	uses: {}
	category: 'Seamless-Proxies'!

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:33'!
xxx___handler

	self subclassResponsibility ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:33'!
xxx___handler: aHandler

	self subclassResponsibility ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 11:35'!
xxx___isProxy

	^ true! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:27'!
xxx___messageIntercepted: aMessage

	aMessage ifNotNil: [

		self xxx___handler xxx___messageInterceptedInProcess: (Processor activeProcess) by: self withSelector: aMessage selector andArguments: aMessage arguments. 
		
	]! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 11:36'!
xxx___remoteObjectId

	self subclassResponsibility ! !

!TSeamlessRemoteProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 11:36'!
xxx___remoteObjectId: aRemoteObjectId

	self subclassResponsibility ! !

Trait named: #TSeamlessRemoteProxyHandler
	uses: {}
	category: 'Seamless-Proxies'!

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:21'!
xxx___messageInterceptCallback

	self subclassResponsibility ! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:21'!
xxx___messageInterceptCallback: aBlock

	self subclassResponsibility ! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:40'!
xxx___messageInterceptedInProcess: aProcess by: aProxy withSelector: aSelector andArguments: args 

	self xxx___messageInterceptCallback ifNotNil: [
		self xxx___messageInterceptCallback value: aProcess value: (RestoreProxiedObjectInfo new localObjectId: aProxy remoteObjectId) value: aSelector value: args
	]! !

!TSeamlessRemoteProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:22'!
xxx___onMessageInterceptEvaluate: aBlock

	self xxx___messageInterceptCallback: aBlock! !

TestCase subclass: #SeamlessFuelTranscoderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

!SeamlessFuelTranscoderTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:33'!
testSerializeMaterialize

	|initialObject transcoder|
	
	initialObject := (1 to: 1000000).
	
	transcoder := SeamlessFuelTranscoder new.
	
	self assert: (initialObject = (transcoder materializeAnObjectFromData: (transcoder serialize: initialObject))).! !

TestCase subclass: #SeamlessGhostProxyTest
	instanceVariableNames: 'proxy systemSelectors nonInterceptedSelectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 14:26'!
prepareMessageSendStringForSelector: aSelector
	
	aSelector isUnary ifTrue: [
		
		^ aSelector asString
		
	] ifFalse: [
		
		aSelector isBinary ifTrue: [
		
			^ aSelector asString , 'nil'.
			
		] ifFalse: [
			| messageSendString|
			
			messageSendString = ''.
			
			(aSelector asString findTokens: #($:)) do: [:token |
				messageSendString := messageSendString , token , ': ' , nil.  	
			].
		
			^ messageSendString
		
		]
	
	]! !

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:28'!
setUp

	proxy := SeamlessGhostProxy new
				handler: (SeamlessGhostProxyHandler new onMessageInterceptEvaluate: [:process :proxiedInfo :selector :arguments |
						systemSelectors remove: selector.
				]).
			
	systemSelectors := Set new.
	
	ProtoObject withAllSubclasses do: [:class | 
		class allSelectors do: [:selector |
			systemSelectors add: selector.	
		]	
	].

	nonInterceptedSelectors := systemSelectors copy.
	
	Smalltalk globals at: #TestProxy put: proxy.! !

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 15:29'!
tearDown 
		
	Smalltalk remove: #TestProxy.! !

!SeamlessGhostProxyTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 14:28'!
testAllSystemSelectors
	
	systemSelectors do: [:selector |
		Compiler evaluate: ('proxy ' , self prepareMessageSendStringForSelector: selector).	
	]! !

TestCase subclass: #SeamlessObjectTransporterTest
	instanceVariableNames: 'numberOfSends peer1 peer2 receivedObjects initialObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Object-Transporter'!

!SeamlessObjectTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:26'!
setUp

	initialObject := (1 to: 100000).
	
	receivedObjects := OrderedCollection new.
		
	numberOfSends := 10.

	peer1 := (SeamlessObjectTransporter newWithTranporter: (SeamlessSocketStreamTransporter new) andTranscoder: (SeamlessFuelTranscoder new)).
	(peer1 startOn: 8080) onObjectReceivedEvaluate: [:conId :object |
		receivedObjects add: object.
	].

	peer2 := (SeamlessObjectTransporter newWithTranporter: (SeamlessSocketStreamTransporter new) andTranscoder: (SeamlessFuelTranscoder new)).
	(peer2 startOn: 8081) onObjectReceivedEvaluate: [:conId :object |
		(1 to: numberOfSends) do: [:i |
			peer2 send: object through: (peer2 connectionIds at: 1).
		]
	].
	
	peer1 connectOn: '127.0.0.1:8081'.! !

!SeamlessObjectTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:53'!
tearDown

	peer1 stop.
	peer2 stop.	
! !

!SeamlessObjectTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:57'!
testEcho

	(1 to: numberOfSends) do: [: i |
		peer1 send: initialObject through: (peer1 connectionIds at: 1).
	].

	(Delay forSeconds: 2) wait.
	
	self assert: ((receivedObjects size) = (numberOfSends raisedTo: 2)).
	
	receivedObjects do: [:data |
		self assert: (data = initialObject).
	].

! !

TestCase subclass: #SeamlessSimpleSocketStreamTransporterTest
	instanceVariableNames: 'peer1 peer2 initialData receivedData numberOfSends'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessSimpleSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:42'!
setUp

	initialData := (1 to: 100000) asString asByteArray.
	
	receivedData := OrderedCollection new.
		
	numberOfSends := 10.

	peer1 := (SeamlessSocketStreamTransporter new startOn: 8080) onDataReceivedEvaluate: [:conId :data |
		receivedData add: data.
	].

	peer2 := (SeamlessSocketStreamTransporter new startOn: 8081) onDataReceivedEvaluate: [:conId :data |
		(1 to: numberOfSends) do: [:i |
			peer2 send: data through: (peer2 connectionIds at: 1).
		]
	].
	
	peer1 connectOn: '127.0.0.1:8081'.

	peer2 connectOn: '127.0.0.1:8080'.  
	
! !

!SeamlessSimpleSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 15:23'!
tearDown

	peer1 stop.
	peer2 stop.	
! !

!SeamlessSimpleSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:57'!
testEcho

	(1 to: numberOfSends) do: [: i |
		peer1 send: initialData through: (peer1 connectionIds at: 1).
	].

	(Delay forSeconds: 2) wait.
	
	self assert: ((receivedData size) = (numberOfSends raisedTo: 2)).
	
	receivedData do: [:data |
		self assert: (data = initialData).
	].
! !

TestCase subclass: #SeamlessSocketStreamTransporterTest
	instanceVariableNames: 'peers initialData receivedData numberOfPeers stoppedConnections numberOfSends simulationWaitingTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

SeamlessSocketStreamTransporterTest class
	instanceVariableNames: 'transporterClass'!

SeamlessSocketStreamTransporterTest class
	instanceVariableNames: 'transporterClass'!

!SeamlessSocketStreamTransporterTest class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 13:44'!
initialize

	super initialize.
	self transporterClass: SeamlessSocketStreamTransporter! !

!SeamlessSocketStreamTransporterTest class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 13:37'!
transporterClass
	^ transporterClass! !

!SeamlessSocketStreamTransporterTest class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 13:37'!
transporterClass: anObject
	transporterClass := anObject! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 20:48'!
connectAll

	peers doWithIndex: [:peer :index |
		((index + 1) to: numberOfPeers) do: [:peerIndex |
				peer connectOn: (peers at: peerIndex) serverAddress.
		]
	].! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:42'!
setUp

	initialData := (1 to: 1000000) asString asByteArray.
	receivedData := OrderedCollection new.
	peers := OrderedCollection new.
	stoppedConnections := OrderedCollection new.
	numberOfPeers := 20. "numberOfPeers Transporters, almost numberOfPeers ^ 2 -- sockets and concurrent connections"
	numberOfSends := 20.
	
	(1 to: numberOfPeers) do: [:i |
		peers add: self class transporterClass new.
		receivedData add: OrderedCollection new.	
	]
	! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 20:48'!
startAll
	
	peers doWithIndex: [:peer :index |
			peer startOn: 8080 + index.
	].! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:30'!
stopAll

	peers do: [:peer | peer stop]! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:30'!
tearDown

	self stopAll! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:30'!
testConnectOn

	self startAll connectAll.
	
	peers do: [:peer |
		self assert: (peer connectionIds size = (numberOfPeers - 1)).	
	]! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 21:35'!
testOnDataReceivedEvaluate

	self startAll connectAll.
	
	peers doWithIndex: [:peer :index |
		peer onDataReceivedEvaluate: [:connectionId :data |
			 (receivedData at: index) add: data. 
		]	
	].

	peers doWithIndex: [:peer :index |
		
		[
		
			(peer connectionIds) do: [:connectionId | 	
	
					(1 to: numberOfSends) do: [:i |
					
						[peer send: initialData through: connectionId. Processor activeProcess terminate. ] fork. "multiple threads simulation ?"	
								
					].

			].
		
			Processor activeProcess terminate.
		
		] fork."multiple peers simulation ?"
	
	].

	self wait.
	
	receivedData do: [:dataCollection |
		self assert: (dataCollection size = (numberOfSends*(peers size -1))).
		dataCollection do: [:data |
			self assert: (data = initialData).
		].
	].	
! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 16:01'!
testOnNewConnectionEvaluate

	|connectionIds|
	
	connectionIds := OrderedCollection new.
		
	self startAll.
	
	peers doWithIndex: [:peer :index |
		connectionIds add: OrderedCollection new.
		peer onNewConnectionEvaluate: [:connectionId | (connectionIds at: index) add: connectionId].
	].
	
	peers doWithIndex: [:peer :index |
		peers doWithIndex: [:otherPeer :otherIndex |
			index < otherIndex ifTrue: [
				peer connectOn: otherPeer serverAddress.
			]
		]	
	].

	connectionIds do: [:connectionsPerPeer |
		self assert: (connectionsPerPeer size = (peers size - 1))		
	 ]! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 14:25'!
testStartOn

	self startAll! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 13:08'!
testStop
	
	self startAll connectAll.
	
	peers doWithIndex: [:peer :index |
		stoppedConnections add: OrderedCollection new.
		peer onStoppedEvaluate: [:conId |
			(stoppedConnections at: index) add: conId.
		]	
	].

	self stopAll.

	peers doWithIndex: [:peer :index |
		self assert: ((stoppedConnections at: index) size = (numberOfPeers - 1)).
	].! !

!SeamlessSocketStreamTransporterTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 17:16'!
wait

	(Delay forSeconds: numberOfPeers*numberOfSends) wait.! !

SeamlessSocketStreamTransporterTest subclass: #SeamlessZodiacTransporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessZodiacTransporterTest class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:45'!
initialize 

	super initialize.
	self transporterClass: SeamlessZodiacTransporter ! !

TestCase subclass: #SeamlessZodiacConnectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

!SeamlessZodiacConnectionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 16:33'!
setUp! !

!SeamlessZodiacConnectionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 16:34'!
tearDown! !

!SeamlessZodiacConnectionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 12:02'!
testReceiveData! !

!SeamlessZodiacConnectionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 16:36'!
testSendData! !

!SeamlessZodiacConnectionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 16:36'!
testStart! !

!SeamlessZodiacConnectionTest methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 16:36'!
testStop! !

GHAbstractProxy subclass: #SeamlessGhostProxy
	uses: TSeamlessRemoteProxy
	instanceVariableNames: 'handler remoteObjectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

SeamlessGhostProxy class
	uses: TSeamlessRemoteProxy classTrait
	instanceVariableNames: ''!

!SeamlessGhostProxy class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:15'!
handleInterception: anInterception

	anInterception proxy xxx___messageIntercepted: (anInterception message selector) withArguments: anInterception message arguments  ! !

!SeamlessGhostProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:34'!
proxyHandler

	^ self xxx___handler! !

!SeamlessGhostProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:35'!
xxx___handler

	^ handler! !

!SeamlessGhostProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:35'!
xxx___handler: aHandler

	handler := aHandler! !

!SeamlessGhostProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:17'!
xxx___remoteObjectId

	^ remoteObjectId ! !

!SeamlessGhostProxy methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:17'!
xxx___remoteObjectId: aRemoteObjectId

	remoteObjectId := aRemoteObjectId ! !

GHProxyHandler subclass: #SeamlessGhostProxyHandler
	uses: TSeamlessRemoteProxyHandler
	instanceVariableNames: 'messageInterceptCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

SeamlessGhostProxyHandler class
	uses: TSeamlessRemoteProxyHandler classTrait
	instanceVariableNames: ''!

!SeamlessGhostProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:57'!
manageMessage: anInterception

	self xxx___messageInterceptedInProcess: Processor activeProcess by: anInterception proxy withSelector: anInterception message selector andArguments: anInterception message arguments.! !

!SeamlessGhostProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:37'!
xxx___messageInterceptCallback

	^ messageInterceptCallback ! !

!SeamlessGhostProxyHandler methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/14/2012 12:37'!
xxx___messageInterceptCallback: aBlock

	messageInterceptCallback := aBlock! !

Object subclass: #AbstractSeamlessConnection
	instanceVariableNames: 'id dataAvailableCallback localAddress remoteAddress incomingDataProcess stopCallback sendSemaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

AbstractSeamlessConnection class
	instanceVariableNames: 'nextId'!

AbstractSeamlessConnection class
	instanceVariableNames: 'nextId'!

!AbstractSeamlessConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:17'!
initialize
	super initialize.
	nextId := 0! !

!AbstractSeamlessConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 14:53'!
new

	nextId := nextId + 1.
	^ super new id: nextId.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:06'!
cleanUp 

	incomingDataProcess terminate! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 21:16'!
dataReceived: data

	"as the callback is currently implemented -- the block evaluation is atomic i.e it has to return for the next receive to continue"

	dataAvailableCallback ifNotNil: [
		dataAvailableCallback value: self id value: data.
	]
	! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 14:52'!
id
	^ id! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 14:52'!
id: anObject
	id := anObject! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 20:49'!
initialize 

	sendSemaphore := Semaphore forMutualExclusion ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:13'!
isConnected

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:28'!
localAddress
	^ localAddress! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:28'!
localAddress: anObject
	localAddress := anObject! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 10:57'!
onDataReceivedEvaluate: aBlock

	dataAvailableCallback := aBlock.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 13:59'!
onStopped

	stopCallback ifNotNil: [
		stopCallback value: self id.
		stopCallback := nil. "normally only one side initiates stop -- we nil the block to avoid duplicated callbacks"
	].

	self cleanUp.
	! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:05'!
onStoppedEvaluate: aBlock

	stopCallback := aBlock.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:09'!
receiveData

	|header|
	
	header := self receiveInteger.
	
	(header = -1) ifTrue: [
		self onStopped.
	] ifFalse: [
		self dataReceived: (self receivePacketSized: header)
	]
	
	! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:53'!
receiveInteger

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:25'!
receivePacketSized: packetSize

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:44'!
remoteAddress
	^ remoteAddress! !

!AbstractSeamlessConnection methodsFor: 'accessing' stamp: 'NickPapoulias 5/9/2012 15:44'!
remoteAddress: anObject
	remoteAddress := anObject! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:23'!
sendData: data

	sendSemaphore critical: [

		self sendPacketSize: data size.
		self sendPacket: data.
		
	].
		! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:53'!
sendInteger: int32

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 22:10'!
sendPacket: data

	self subclassResponsibility ! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:22'!
sendPacketSize: int32

	self sendInteger: int32.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 16:29'!
sendStop

		self sendInteger: -1
! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:47'!
start

	incomingDataProcess := [
		
		[self receiveData] repeat
		
	] fork.! !

!AbstractSeamlessConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:50'!
stop

	self isConnected ifTrue: [
		self sendStop.
	].

	self onStopped.! !

AbstractSeamlessConnection subclass: #SeamlessSocketStreamConnection
	instanceVariableNames: 'stream socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

SeamlessSocketStreamConnection class
	instanceVariableNames: 'SocketStreamClass'!

SeamlessSocketStreamConnection class
	instanceVariableNames: 'SocketStreamClass'!

!SeamlessSocketStreamConnection class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:09'!
initialize

	super initialize.
	self socketStreamClass: SocketStream.! !

!SeamlessSocketStreamConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 12:19'!
newOnSocket: aSocket 

	^ self new
		withSocket: aSocket;
		localAddress: aSocket localAddress asString , ':' , aSocket localPort asString;
		remoteAddress: aSocket remoteAddress asString , ':' , aSocket remotePort asString.
! !

!SeamlessSocketStreamConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:17'!
openConnectionToHost: address port: port
	
	|stream|
	
	stream := self socketStreamClass openConnectionToHost: address port: port. 
	
	^ self new
		withStream: stream;
		localAddress: stream socket localAddress asString , ':' , stream socket localPort asString;
		remoteAddress: stream socket remoteAddress asString , ':' , stream socket remotePort asString.
! !

!SeamlessSocketStreamConnection class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:08'!
socketStreamClass
	^ SocketStreamClass! !

!SeamlessSocketStreamConnection class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:08'!
socketStreamClass: anObject
	SocketStreamClass := anObject! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:15'!
isConnected 

	^ stream isConnected ! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:54'!
receiveInteger
	"Read a 32-bit signed integer from the next 4 bytes"
	| s |
	s := 0.
	1 to: 4 do: [:i | s := (s bitShift: 8) + stream next asInteger].
	(s bitAnd: 16r80000000) = 0
		ifTrue: [^ s]
		ifFalse: [^ -1 - s bitInvert32]! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:15'!
receivePacketSized: packetSize

	^ (stream next: packetSize)! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:17'!
sendInteger: int32
	"Write a signed integer to the next 4 bytes"
	| pos |
	pos := int32 < 0
		ifTrue: [(0-int32) bitInvert32 + 1]
		ifFalse: [int32].
	1 to: 4 do: [:i | stream nextPut: (pos digitAt: 5-i)].
	stream flush.
	^ int32! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:16'!
sendPacket: data

	stream nextPutAll: data.
	stream flush! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 11:55'!
stop

	super stop.

	stream close.! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:41'!
withSocket: aSocket 

	socket := aSocket.
	stream := self class socketStreamClass on: socket.
	stream timeout: 0.
	stream binary.! !

!SeamlessSocketStreamConnection methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:41'!
withStream: aStream 

	socket := aStream socket.
	stream := aStream.
	stream timeout: 0.
	stream binary.! !

SeamlessSocketStreamConnection subclass: #SeamlessZodiacConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

!SeamlessZodiacConnection class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:45'!
initialize

	super initialize.
	self socketStreamClass: ZdcSocketStream! !

AbstractSeamlessConnection subclass: #SeamlessZincCommetConnection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Connection'!

Object subclass: #AbstractSeamlessTranscoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

!AbstractSeamlessTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 23:15'!
materializeAnObjectFromData: data

	self subclassResponsibility ! !

!AbstractSeamlessTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:54'!
serialize: anObject

	self subclassResponsibility ! !

AbstractSeamlessTranscoder subclass: #SeamlessFuelTranscoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:44'!
materializeAnObjectFromData: data

	 ^ (FLMaterializer  newDefault materializeFrom: (ReadStream on: data)) root.! !

!SeamlessFuelTranscoder methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:44'!
serialize: anObject

	|stream|
	
	stream := WriteStream on: {}.

	(FLSerializer newDefault serialize: anObject on: stream).
	
	^ stream contents.! !

AbstractSeamlessTranscoder subclass: #SeamlessJSONTranscoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

AbstractSeamlessTranscoder subclass: #SeamlessSTONTranscoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Transcoder'!

Object subclass: #CreateNewProxyInfo
	instanceVariableNames: 'remoteObjectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

!CreateNewProxyInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:12'!
remoteObjectId
	^ remoteObjectId! !

!CreateNewProxyInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:12'!
remoteObjectId: anObject
	remoteObjectId := anObject! !

Object subclass: #RestoreProxiedObjectInfo
	instanceVariableNames: 'localObjectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Proxies'!

!RestoreProxiedObjectInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:13'!
localObjectId
	^ localObjectId! !

!RestoreProxiedObjectInfo methodsFor: 'accessing' stamp: 'NickPapoulias 5/14/2012 11:13'!
localObjectId: anObject
	localObjectId := anObject! !

Object subclass: #SeamlessAbstractTransporter
	instanceVariableNames: 'incomingConnectionsProcess seamlessConnections dataAvailableCallback newConnectionCallback stoppedCallback serverAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

SeamlessAbstractTransporter class
	instanceVariableNames: 'seamlessConnectionClass'!

SeamlessAbstractTransporter class
	instanceVariableNames: 'seamlessConnectionClass'!

!SeamlessAbstractTransporter class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:59'!
seamlessConnectionClass
	^ seamlessConnectionClass! !

!SeamlessAbstractTransporter class methodsFor: 'accessing' stamp: 'NickPapoulias 5/10/2012 12:59'!
seamlessConnectionClass: anObject
	seamlessConnectionClass := anObject! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:38'!
addNewConnection: aSeamlessConnection

	seamlessConnections at: aSeamlessConnection id put: aSeamlessConnection.
	self newConnectionAdded: aSeamlessConnection.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:40'!
connectOn: aRemoteAddressAsString

	self subclassResponsibility.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 15:50'!
connectionIds

	^ seamlessConnections keys.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:23'!
handleConnectionRequests

	self subclassResponsibility ! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 14:07'!
initialize 

	super initialize.
	seamlessConnections := Dictionary new.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:39'!
newConnectionAdded: aSeamlessConnection

	newConnectionCallback ifNotNil: [newConnectionCallback value: aSeamlessConnection id].! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 09:28'!
onDataReceivedEvaluate: aBlock

	dataAvailableCallback := aBlock.
	seamlessConnections do: [:sConnection |
		sConnection onDataReceivedEvaluate: aBlock.	
	]! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/6/2012 16:12'!
onNewConnectionEvaluate: aBlock

	newConnectionCallback := aBlock.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:43'!
onStoppedEvaluate: aBlock

	stoppedCallback := aBlock.
	seamlessConnections do: [:sConnection |
		sConnection onStoppedEvaluate:  aBlock.	
	]! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 16:00'!
send: dataAsByteArray through: aSeamlessConnectionId

	(seamlessConnections at: aSeamlessConnectionId) sendData: dataAsByteArray.! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 08:49'!
serverAddress

	^ serverAddress! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 08:50'!
serverAddress: aServerIdentifier

	serverAddress := aServerIdentifier ! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 20:09'!
start

	incomingConnectionsProcess := [ 
	
			      self handleConnectionRequests.
	
	] fork! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 15:35'!
startOn: anIdentifier

	self subclassResponsibility ! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 15:01'!
stop

	seamlessConnections ifNotNil: [
		seamlessConnections keysDo: [:aConnectionId | 
			self stop: aConnectionId.	
		]
	].

	incomingConnectionsProcess ifNotNilDo: [:process | process terminate ].
	! !

!SeamlessAbstractTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/9/2012 14:59'!
stop: aSeamlessConnectionId

	(seamlessConnections at: aSeamlessConnectionId) stop.! !

SeamlessAbstractTransporter subclass: #SeamlessSocketStreamTransporter
	instanceVariableNames: 'serverSocket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessSocketStreamTransporter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 12:59'!
initialize

	super initialize.
	self seamlessConnectionClass: SeamlessSocketStreamConnection.! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:20'!
connectOn: aRemoteAddressAsString
	
	|clientStream address port newConnection|

	address := ByteArray new writeStream.
	
	((aRemoteAddressAsString findTokens: #($. $:)) doWithIndex: [:item :index |
		(index < 5) ifTrue: [
			address nextPut: item asInteger		
		] ifFalse: [
			port := item asInteger
		]	
	]).
	
	newConnection := (self class seamlessConnectionClass openConnectionToHost: address contents port: port)
									onDataReceivedEvaluate: dataAvailableCallback;
									start.
	
	self addNewConnection: newConnection.
	
	^ newConnection id.

! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 20:09'!
handleConnectionRequests

	|clientSocket|
	
	[
	
		clientSocket := serverSocket waitForAcceptFor: 10.
		clientSocket ifNotNil: [ 
				| newConnection |
				newConnection := (self class seamlessConnectionClass newOnSocket: clientSocket)
									onDataReceivedEvaluate: dataAvailableCallback;
									start.
				self addNewConnection: newConnection 
		]
	
	] repeat ! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 12:56'!
start

	self startOn: 8080.! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:25'!
startOn: aPortNumber

	| clientSocket stream aPortAsString |

	aPortAsString := aPortNumber asString.

	(serverSocket := Socket newTCP)
		setOption: 'TCP_NODELAY' value: 1;
		setOption: 'SO_SNDBUF' value: 4096;
		setOption: 'SO_RCVBUF' value: 4096.

	serverSocket listenOn: aPortAsString asNumber backlogSize: 32.

	serverSocket isValid
		ifFalse: [ self error: 'Cannot create socket on port ' , aPortAsString ].
		
	self serverAddress: '127.0.0.1:' , aPortAsString.

	super start! !

!SeamlessSocketStreamTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 12:36'!
stop
	
	super stop.
	
	serverSocket close.! !

SeamlessSocketStreamTransporter subclass: #SeamlessZodiacTransporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessZodiacTransporter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:00'!
initialize

	super initialize.
	self seamlessConnectionClass: SeamlessZodiacConnection! !

SeamlessAbstractTransporter subclass: #SeamlessZincCommetTransporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessZincCommetTransporter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/10/2012 13:01'!
initialize

	super initialize.
	self seamlessConnectionClass: SeamlessZincCommetConnection.! !

Object subclass: #SeamlessDependencies
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Data-Transporter'!

!SeamlessDependencies class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 14:32'!
load

"Gofer it
	squeaksource: 'ZincHTTPComponents';
	package: 'Zinc-Zodiac';
	load.
	
Gofer it
	squeaksource: 'Zodiac';
	package: 'Zodiac-Core';
	package: 'Zodiac-Tests';
	package: 'Zodiac-Extra';
	load.
	
(ConfigurationOfFuel project version: #bleedingEdge) load

Gofer it
url: 'http://ss3.gemstone.com/ss/Ghost';
package: 'ConfigurationOfGhost';
load.

(Smalltalk at: #ConfigurationOfGhost) load"! !

!SeamlessDependencies class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/11/2012 14:30'!
misc

	VirtualMachine maxExternalSemaphoresSilently: 65535
	VirtualMachine maxExternalSemaphores

	"also remember the limit of concurrent connections from the OS"

	"socket best strategy -- one socket per execution path"! !

Object subclass: #SeamlessObjectTransporter
	instanceVariableNames: 'transporter transcoder objectReceivedCallback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seamless-Object-Transporter'!

!SeamlessObjectTransporter class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:27'!
newWithTranporter: aTransporter andTranscoder: aTranscoder

	^ self new 
		withTranscoder: aTranscoder;
		withTransporter: aTransporter.! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:40'!
connectOn: aRemoteAddressAsString

	transporter connectOn: aRemoteAddressAsString 

	! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:37'!
connectionIds 

	^ transporter connectionIds ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:38'!
connectionInfoFor: aConnectionId

	! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:29'!
onNewConnectionEvaluate: aBlock

	transporter onNewConnectionEvaluate: aBlock! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/13/2012 00:28'!
onObjectReceivedEvaluate: aBlock

	"mind the string/bytearray dif"

	transporter onDataReceivedEvaluate: [:connectId :data |
		aBlock value: connectId value: (transcoder materializeAnObjectFromData: data).	
	]! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:29'!
onStoppedEvaluate: aBlock

	transporter onStoppedEvaluate: aBlock! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:30'!
onTransportingErrorEvaluate: aBlock

	transporter onTransportingErrorEvaluate: aBlock! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:30'!
send: anObject through: aSeamlessConnectionId

	transporter send: (transcoder serialize: anObject) through: aSeamlessConnectionId ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:43'!
serverAddress 

	^ transporter serverAddress 
	! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:43'!
start

	transporter start! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:44'!
startOn: anIdentifier

	transporter startOn: anIdentifier ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:45'!
stop

	transporter stop! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:50'!
stop: aSeamlessConnectionId

	transporter stop: aSeamlessConnectionId ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:35'!
withTranscoder: aTranscoder

	transcoder := aTranscoder ! !

!SeamlessObjectTransporter methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 5/12/2012 22:36'!
withTransporter: aTransporter

	transporter := aTransporter ! !
SeamlessSocketStreamTransporter initialize!
SeamlessZincCommetTransporter initialize!
AbstractSeamlessConnection initialize!
SeamlessSocketStreamConnection initialize!
SeamlessZodiacConnection initialize!
SeamlessSocketStreamTransporterTest initialize!
SeamlessZodiacTransporterTest initialize!
SeamlessZodiacTransporter initialize!
